<script>
import { mapActions, mapState } from 'pinia';
import { GlLoadingIcon } from '@gitlab/ui';
import { useDockerStore } from './stores/docker';
import { useMainStore } from './stores/main';
import { useWorkflowStore } from './stores/workflow';
import { WORKFLOW_NEW_APP } from './router/constants';
import WorkflowIndex from './pages/index/workflow_index.vue';
import WorkflowHealthCheck from './common/workflow_health_check.vue';
import { useHealthCheckStore } from './stores/health_check';
import Breadcrumb from './router/breadcrumb.vue';
import { isPageWithoutContainer, isPageWithLimitedWidth } from './router/utils';

export default {
  components: {
    Breadcrumb,
    GlLoadingIcon,
    WorkflowHealthCheck,
    WorkflowIndex,
  },
  created() {
    this.notifyAppReady();
    this.verifyDockerImage();
    this.getProjectPath();
  },
  computed: {
    ...mapState(useDockerStore, { isDockerReady: 'isReady' }),
    ...mapState(useHealthCheckStore, ['isDuoWorkflowEnabled', 'isLoadingHealthCheck']),
    ...mapState(useMainStore, ['projectPath', 'isLoadingProjectPath']),
    ...mapState(useWorkflowStore, ['initialState']),
    containerClasses() {
      const width = isPageWithLimitedWidth(this.$route.name) ? 'gl-mx-auto gl-max-w-limited' : '';
      const container = isPageWithoutContainer(this.$route.name) ? '' : 'gl-pt-12';
      return `${width} ${container}`;
    },
  },
  watch: {
    initialState() {
      if (this.initialState.goal) {
        this.$router.push({ name: WORKFLOW_NEW_APP });
      }
    },
  },
  methods: {
    ...mapActions(useDockerStore, ['verifyDockerImage']),
    ...mapActions(useMainStore, ['getProjectPath', 'notifyAppReady']),
  },
};
</script>
<template>
  <div class="gl-px-4 gl-relative gl-h-full">
    <workflow-health-check v-if="!isDuoWorkflowEnabled" />
    <div v-else class="gl-h-full">
      <breadcrumb class="gl-absolute gl-top-7 gl-left-4 gl-w-3/5" />
      <router-view :class="containerClasses" />
    </div>
  </div>
</template>
